library clipper_header;
import 'package:flutter/material.dart';

/// A Calculator.
class ClipperHeader {
  Widget _list;
  double _height;
  String _date;
  String _image;
  String _title;
  String _userImage;
  String _userName;
  String _description;

  set list(str)=>this._list=str;
  set height(str)=>this._height=str;
  set date(str)=>this._date=str;
  set image(img)=>this._image=img;
  set title(str)=>this._title=str;
  set userImage(str)=>this._userImage=str;
  set userName(str)=>this._userName=str;
  set description(str)=>this._description=str;
  ClipperHeader();
  Widget create(){
    return Stack(
        children: <Widget>[
          _buildImage(),
          _buildHeader(),
          _buildProfileRow(),
          _buildBottomPart()
        ],
      );
  }
  _buildImage(){
    return new ClipPath(
      clipper: LogoClipper(),
      child: new Image.asset(
        _image,
        fit:BoxFit.fill,
        height: _height,
      )
    );
  }
  _buildHeader(){
    return Padding(
      padding: const EdgeInsets.symmetric(vertical: 32.0,horizontal:8.0),
      child: new Row(
        children: <Widget>[
          Icon(Icons.menu,size:32.0,color:Colors.white),
          Expanded(
            child:  Padding(
              padding: const EdgeInsets.only(left: 8.0),
              child: new Text(
                _title,
                style: new TextStyle(
                    fontSize: 20.0,
                    color: Colors.white,
                    fontWeight: FontWeight.w300),
              ),
            ),
          ),
          Icon(Icons.linear_scale,size:32.0,color:Colors.white),

        ],
      ),
    );
  }
  _buildProfileRow(){
    return new Padding(
    padding: new EdgeInsets.only(left: 16.0, top: _height / 2.5),
    child: new Row(
      children: <Widget>[
        (!_userImage.isNotEmpty)?new CircleAvatar(
          minRadius: 28.0,
          maxRadius: 28.0,
          backgroundImage: new AssetImage(_userImage),
        ):null,new Padding(
          padding: const EdgeInsets.only(left: 16.0),
          child: new Column(
            crossAxisAlignment: CrossAxisAlignment.start,
            mainAxisSize: MainAxisSize.min,
            children: <Widget>[
              (_userName.isNotEmpty)?new Text(
                _userName,
                style: new TextStyle(
                    fontSize: 26.0,
                    color: Colors.white,
                    fontWeight: FontWeight.w400),
              ):null,
              (_description.isNotEmpty)?new Text(
                _description,
                style: new TextStyle(
                    fontSize: 14.0,
                    color: Colors.white,
                    fontWeight: FontWeight.w300),
              ):null,
            ],
          ),
        ),
      ],
    ),
  );
  }
  _buildBottomPart() {
    return new Padding(
      padding: new EdgeInsets.only(top:_height),
      child: new Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
          _buildMyTasksHeader(),
          _buildTasksList(),
        ],
      ),
    );
  }
  _buildTasksList() {
    return _list;
  }
  _buildMyTasksHeader() {
  return new Padding(
    padding: new EdgeInsets.only(left: 64.0),
    child: new Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: <Widget>[
        new Text(
          _title,
          style: new TextStyle(fontSize: 34.0),
        ),
        new Text(
          _date,
          style: new TextStyle(color: Colors.grey, fontSize: 12.0),
        ),
      ],
    ),
  );
}

}




class LogoClipper extends CustomClipper<Path>{
  @override
  Path getClip(Size size) {
    Path path = new Path()
      ..lineTo(0.0, size.height-60.0)
      ..lineTo(size.width, size.height)
      ..lineTo(size.width, 0.0)
      ..close();
      return path;
  }
  @override
  bool shouldReclip(CustomClipper oldClipper)=>true;
}